//
//  RSSFeedWatcher.h
//  UsenetEngine
//
//  Created by Ger Teunis on 09-02-13.
//
//

#import <Foundation/Foundation.h>
#import "RSSFeed.h"

@interface RSSFeedWatcher : NSObject <NSCoding> {
    NSNumber *enabled;
    RSSFeed *feed;
    NSString *name;
    bool hasNewItems;
    NSDate *lastProcessedDate;
    NSString *_includeFilter;
	NSString *_excludeFilter;
	NSString *_categoryFilter;
	NSNumber *_beginSeason;
	NSNumber *_beginEpisode;
	NSNumber *addNZBsPaused;
	NSNumber *skipProcessing;
    NSNumber *autoDownload;
    NSString *downloadGroupUUID;
    NSDate *userLastWatchedDate;
    NSNumber *_isTVShowWatcher;
    NSMutableArray *downloadedTVEpisodes;
    NSNumber *downloadTVEpisodeRepacks;
}

@property (retain, atomic) NSNumber *enabled;
@property (retain, atomic) RSSFeed *feed;
@property (retain, atomic) NSString *name;
@property (assign, atomic) bool hasNewItems;
@property (retain, atomic) NSDate *lastProcessedDate;
@property (retain, atomic) NSNumber *addNZBsPaused;
@property (retain, atomic) NSNumber *skipProcessing;
@property (retain, atomic) NSNumber *autoDownload;
@property (retain, atomic) NSString *downloadGroupUUID;
@property (retain, atomic) NSDate *userLastWatchedDate;
@property (retain, atomic) NSNumber *isTVShowWatcher;
@property (retain, atomic) NSNumber *beginEpisode;
@property (retain, atomic) NSNumber *beginSeason;
@property (retain, atomic) NSMutableArray *downloadedTVEpisodes;
@property (retain, atomic) NSNumber *downloadTVEpisodeRepacks;

-(NSArray*)getFilteredFeedsUsingEpisodeFilter:(BOOL)episodeFilter;
-(NSArray*)getFilteredFeedsUsingEpisodeFilter:(BOOL)episodeFilter explicitIncludeFilter:(NSString*)explicitIncludeFilter;
-(void)addDownloadedTVSeason:(int)season episode:(int)episode isRepack:(BOOL)repack;
-(NSString*)includeFilter;
-(void)setIncludeFilter:(NSString *)includeFilter;
-(NSString*)excludeFilter;
-(void)setExcludeFilter:(NSString *)excludeFilter;
-(NSArray*)filteredPreview;
-(void)setFilteredPreview:(NSArray*)value;
+(BOOL)parseFeedTitle:(NSString*)title season:(int*)season episode:(int*)episode repack:(BOOL*)repack;
-(void)setAllFeedItemsProcessedState:(BOOL)state;
-(void)updateHasNewItems;
-(bool)downloadMatchingFeedItems;
-(void)sortDownloadedTVEpisodes;

@end
